> For the complete documentation index, see [llms.txt](https://developers.make.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.make.com/custom-apps-development-training/version-3/getting-started.md).

# Getting started

The App Academy API version 3 was developed for the practical challenge within the Custom Apps Development course. Access ( username and password ) can be obtained [there](https://partnertraining.make.com/courses/custom-apps-development-training).

## Authorization flow

### Step one: Obtain a new token

Before getting access to API version 3, you will need your `username` and `password` to get a new access token.

Use your application `username` and `password` to issue a request to `token` endpoint.

You must use `password` grant type.

A successful request will respond with `access_token` , `expires-in` , and `refresh_token` parameters. `Expires-in` value is in minutes.

{% openapi src="/files/BfQxaB4iHmbIHmswuBRu" path="/token" method="post" %}
[KLOBOUCKOVATEREZA\_1-chall-1.0.0-swagger.yaml](https://3114796191-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgNTg64InL2Ea6QArLuAq%2Fuploads%2FZr2C773ZoeWi9Tg0y97N%2FKLOBOUCKOVATEREZA_1-chall-1.0.0-swagger.yaml?alt=media\&token=d950318e-367f-47c6-b7d8-9aa8738aaa97)
{% endopenapi %}

### Step two: Make an API request

After obtaining the access token, you can send requests to App Academy API that contain the `authorization` header in this format: `Bearer {access_token}`.

{% openapi src="/files/7nBBMobBqUyFquH26z7Z" path="/whoami" method="get" %}
[KLOBOUCKOVATEREZA\_1-chall-1.0.0-swagger (28) (1).yaml](https://3114796191-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgNTg64InL2Ea6QArLuAq%2Fuploads%2FP6eaCM0PUjjHCOeJAlAJ%2FKLOBOUCKOVATEREZA_1-chall-1.0.0-swagger%20\(28\)%20\(1\).yaml?alt=media\&token=24ad132e-1b8a-473e-aa68-9a353aaf6d23)
{% endopenapi %}

### Step three: Refresh the access token

The API provides the `expires_in` parameter in the `token` response to determine if the user's access token has expired. If it has, to obtain a new access token use the `token` endpoint with `grant_type` set to `refresh_token` .

`Expires-in` value is in minutes. To obtain a new access token and refresh token, the refresh token must not be expired!

{% openapi src="/files/7nBBMobBqUyFquH26z7Z" path="/token" method="post" %}
[KLOBOUCKOVATEREZA\_1-chall-1.0.0-swagger (28) (1).yaml](https://3114796191-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgNTg64InL2Ea6QArLuAq%2Fuploads%2FP6eaCM0PUjjHCOeJAlAJ%2FKLOBOUCKOVATEREZA_1-chall-1.0.0-swagger%20\(28\)%20\(1\).yaml?alt=media\&token=24ad132e-1b8a-473e-aa68-9a353aaf6d23)
{% endopenapi %}

### Error handling

Error example

<pre class="language-json"><code class="lang-json">{
<strong>    "error": {
</strong>        "message": "Grant type not supported.",
        "code": 501
<strong>    }
</strong>}
</code></pre>

### Pagination

App Academy API uses pagination to limit the response size for resources that return a potentially large collection of items. A request to a paged API will result in a `results` array wrapped in a JSON object with paging metadata, for example:

<pre><code>{
    "totalRecordsReturned": 5,
    "records": [
        {
            "id": "1dca6a93fcf1",
            "name": "Robert Downey Jr.",
            "createdAt": "2023-04-13T17:04:47+00:00",
            "updatedAt": "2023-04-19T17:04:47+00:00"
<strong>        }
</strong>    ]
}
</code></pre>

* `totalRecordsReturned` - The number of results returned on the page.

{% hint style="info" %}
The default (and maximum) page size in pagination is 5.

The default (and maximum) limit of retrieved records is 20.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.make.com/custom-apps-development-training/version-3/getting-started.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
